CLA_tree = "DMG"
CLA_mode = "Announce"
CLA_SelectedSpells = {}

function CritlineAnnounce_ShowAnnounce()
	CLA_SelectedSpells = {}
	Critline_Announce:Show()
	CritlineSettings_Frame:Hide()
end

function CritlineAnnounce_CreateChannel(curValue, curText)
	local tex1 = {
		text = curText,
		value = curValue,
		func = function()
			UIDropDownMenu_SetSelectedValue(Critline_AnnounceChannel, curValue)
			if curValue == 15 then
				Critline_AnnouncePlayer:Show()
				Critline_AnnouncePlayer:SetFocus()
			else
				Critline_AnnouncePlayer:Hide()
			end
		end
	}
	UIDropDownMenu_AddButton(tex1)
end

function CritlineAnnounce_SendAnnounce()
	local norm
	local crit
	local normcrit
	local mychanID = UIDropDownMenu_GetSelectedValue(Critline_AnnounceChannel)
	if mychanID == 0 or mychanID == nil then
		Critline_Message("Critline Announce: "..CL_ANNOUNCE_MISSINGCHANNEL_TEXT..".")
		return
	end 
	local mychan
	if mychanID == 11 then
		mychan = "GUILD"
	elseif mychanID == 12 then
		mychan = "PARTY"
	elseif mychanID == 13 then
		mychan = "RAID"
	elseif mychanID == 14 then
		mychan = "SAY"
	elseif mychanID == 15 then
		mychan = "WHISPER"
		mychanID = Critline_AnnouncePlayer:GetText()
		if mychanID == "" then
			Critline_Message("Critline Announce: "..CL_ANNOUNCE_BADPLAYER_TEXT..".")
			return
		end
	else
		mychan = "CHANNEL"
	end
	
	for i = 1, #CLA_SelectedSpells do
		norm = nil
		crit = nil
		if CL_DATABASE[CLA_tree][CLA_SelectedSpells[i]]["NORM"] then
			norm = CL_DATABASE[CLA_tree][CLA_SelectedSpells[i]]["NORM"]["Amount"]
		end
		if CL_DATABASE[CLA_tree][CLA_SelectedSpells[i]]["CRIT"] then
			crit = CL_DATABASE[CLA_tree][CLA_SelectedSpells[i]]["CRIT"]["Amount"]
		end
		if norm and crit then
			normcrit = CL_NORMAL_TEXT..": "..norm.." "..CL_CRIT_TEXT..": "..crit
		elseif norm then
			normcrit = CL_NORMAL_TEXT..": "..norm.." "..CL_CRIT_TEXT..": N/A"
		elseif crit then
			normcrit = CL_NORMAL_TEXT..": N/A "..CL_CRIT_TEXT..": "..crit
		end
		SendChatMessage(CLA_SelectedSpells[i].." - "..normcrit, mychan, nil, mychanID)
	end

	
	Critline_AnnouncePlayer:ClearFocus()
end

function CritlineAnnounce_ResetRecords()
	local mytree = UIDropDownMenu_GetSelectedValue(Critline_AnnounceTree)
	if Critline_AnnounceAllButton:GetChecked() then
		CL_DATABASE[CLA_tree] = {}
		Critline_AnnounceAllButton:SetChecked(false)
	else
		for i = 1, table.maxn(CLA_SelectedSpells) do
			norm = nil
			crit = nil
			for v in pairs(CL_DATABASE[CLA_tree]) do
				if v == CLA_SelectedSpells[i] then
					CL_DATABASE[CLA_tree][CLA_SelectedSpells[i]] = nil
					do break end
				end
			end
		end
	end
	CLA_SelectedSpells = {}

	CLASpellScrollBar_Update()
	Critline_RebuildAllTooltips()
end

function CritlineAnnounce_LoadChannels()
	if IsInGuild() then
		CritlineAnnounce_CreateChannel(11, GUILD)
	end
	if GetNumPartyMembers() > 0 then
		CritlineAnnounce_CreateChannel(12, PARTY)
	end
	if GetNumRaidMembers() > 0 then
		CritlineAnnounce_CreateChannel(13, RAID)
	end
	
	CritlineAnnounce_CreateChannel(14, SAY)
	CritlineAnnounce_CreateChannel(15, PLAYER)

	local id, name
	
	for i = 1, 10 do
		id, name = select((i * 2 - 1), GetChannelList())
		if id then
			CritlineAnnounce_CreateChannel(id, name)
		end
	end
end

function CritlineAnnounce_ChannelInitialize()
	UIDropDownMenu_Initialize(Critline_AnnounceChannel, CritlineAnnounce_LoadChannels)
	UIDropDownMenu_SetWidth(Critline_AnnounceChannel, 120)
end

function CritlineAnnounce_TreeInitialize()
	UIDropDownMenu_Initialize(Critline_AnnounceTree, function()
		local tex
		tex = {
			text = DAMAGE,
			value = 1,
			func = function()
				UIDropDownMenu_SetSelectedValue(Critline_AnnounceTree, 1)
				CLA_SelectedSpells = {}
				FauxScrollFrame_SetOffset(CLASpellScrollBar, 0)
				CLA_tree = "DMG"
				CLASpellScrollBar_Update()
			end
		}
		UIDropDownMenu_AddButton(tex)
		
		tex = {
			text = HEALS,
			value = 2,
			func = function()
				UIDropDownMenu_SetSelectedValue(Critline_AnnounceTree, 2)
				CLA_SelectedSpells = {}
				FauxScrollFrame_SetOffset(CLASpellScrollBar, 0)
				CLA_tree = "HEAL"
				CLASpellScrollBar_Update()
			end
		}
		UIDropDownMenu_AddButton(tex)
		
		tex = {
			text = PET,
			value = 3,
			func = function()
				UIDropDownMenu_SetSelectedValue(Critline_AnnounceTree, 3)
				CLA_SelectedSpells = {}
				FauxScrollFrame_SetOffset(CLASpellScrollBar, 0)
				CLA_tree = "PET"
				CLASpellScrollBar_Update()
			end
		}
		UIDropDownMenu_AddButton(tex)
	end)
	UIDropDownMenu_SetWidth(Critline_AnnounceTree, 120)
end

function CritlineAnnounce_SpellButton_OnClick(self)
	local id = self:GetID()
	if self:GetChecked() then
		PlaySound("igMainMenuOptionCheckBoxOn")
		tinsert(CLA_SelectedSpells, _G["CLASpellButton"..id.."Text"]:GetText())
	else
		PlaySound("igMainMenuOptionCheckBoxOff")
		for i = 1, #CLA_SelectedSpells do
			if CLA_SelectedSpells[i] == _G["CLASpellButton"..id.."Text"]:GetText() then
				tremove(CLA_SelectedSpells, i)
				return
			end
		end
	end
end

function CLASpellScrollBar_Update()
	local lineplusoffset -- an index into our data calculated from the scroll offset
	local CLA_SPELLS = {}
	local norm, crit, normcrit, checked

	for k, v in pairs(CL_DATABASE[CLA_tree]) do
		if type(k) == "number" then
			CL_DATABASE[CLA_tree] = nil -- need to get rid of old 113 errors...they are stored as numbers and cause errors when compared with string names
		else
			tinsert(CLA_SPELLS, k)
		end
	end
	sort(CLA_SPELLS)
	local size = #CLA_SPELLS
	local buttonName, button, text
	FauxScrollFrame_Update(CLASpellScrollBar, size, 16, 16)
	for line = 1, 16 do
		norm = 0
		crit = 0
		buttonName = "CLASpellButton"
		button = _G[buttonName..line]
		text = _G[buttonName.."Text"..line]
		lineplusoffset = line + FauxScrollFrame_GetOffset(CLASpellScrollBar)
		if lineplusoffset <= size then
			_G[buttonName..line.."Text"]:SetText(CLA_SPELLS[lineplusoffset])
			if CL_DATABASE[CLA_tree][CLA_SPELLS[lineplusoffset]]["NORM"] then
				norm = CL_DATABASE[CLA_tree][CLA_SPELLS[lineplusoffset]]["NORM"]["Amount"]
			end
			if CL_DATABASE[CLA_tree][CLA_SPELLS[lineplusoffset]]["CRIT"] then
				crit = CL_DATABASE[CLA_tree][CLA_SPELLS[lineplusoffset]]["CRIT"]["Amount"]
			end
			if norm and crit then
				normcrit = HIGHLIGHT_FONT_COLOR_CODE..norm..FONT_COLOR_CODE_CLOSE.."/"..GREEN_FONT_COLOR_CODE..crit..FONT_COLOR_CODE_CLOSE
			elseif norm then
				normcrit = HIGHLIGHT_FONT_COLOR_CODE..norm..FONT_COLOR_CODE_CLOSE
			elseif crit then
				normcrit = GREEN_FONT_COLOR_CODE..crit..FONT_COLOR_CODE_CLOSE
			end
			text:SetText("["..normcrit.."] ")
			checked = false
			for k, v in ipairs(CLA_SelectedSpells) do
				if v == CLA_SPELLS[lineplusoffset] then
					checked = true
					break
				end
			end
			button:SetChecked(checked)
			button:Show()
			text:Show()
		else
			button:Hide()
			text:Hide()
		end
	end
end

--xml function calls
function CLASpellScrollBar_OnVerticalScroll(self, offset)
	FauxScrollFrame_OnVerticalScroll(self, offset, 16, CLASpellScrollBar_Update)
end

function CritlineAnnounce_AllButton_OnClick(self)
	if self:GetChecked() then
		PlaySound("igMainMenuOptionCheckBoxOn")
	else
		PlaySound("igMainMenuOptionCheckBoxOff")
	end
end

function CritlineAnnounce_Button1_OnClick()
	PlaySound("gsTitleOptionOK")
	if CLA_mode == "Announce" then
		CritlineAnnounce_SendAnnounce()
	else
		CritlineAnnounce_ResetRecords()
	end
end

function CritlineAnnounce_OnShow()
	if CLA_mode == "Announce" then
		Critline_Announce_Button1:SetText(CL_ANNOUNCE_TEXT)
		Critline_AnnounceAllButton:Hide()
		Critline_AnnounceTitleString:SetText(CL_ANNOUNCE_TITLE_TEXT)
		Critline_AnnounceChannel:Show()
	else
		Critline_AnnounceChannel:Hide()
		Critline_AnnounceAllButton:Show()
		Critline_Announce_Button1:SetText(RESET)
		Critline_AnnounceTitleString:SetText(CL_RESET_TITLE_TEXT)
	end
	CLA_tree = "DMG"
	CLASpellScrollBar_Update()
	Critline_AnnouncePlayer:SetAutoFocus(false)
	Critline_AnnouncePlayer:Hide()
	CritlineAnnounce_ChannelInitialize()
	UIDropDownMenu_SetText(Critline_AnnounceChannel, SAY)
	UIDropDownMenu_SetSelectedValue(Critline_AnnounceChannel, 14)
	CritlineAnnounce_TreeInitialize()
	UIDropDownMenu_SetText(Critline_AnnounceTree, DAMAGE)
	UIDropDownMenu_SetSelectedValue(Critline_AnnounceTree, 1)
end

function CritlineAnnounce_OnHide()
	CritlineSettings_Frame:Show()
end

function CritlineAnnounce_OnLoad(self)
	self:RegisterForDrag("LeftButton")
	CritlineAnnounce_Localize()
end

function CritlineAnnounce_OnDragStart(self)
	self:StartMoving()
end

function CritlineAnnounce_OnDragStop(self)
	self:StopMovingOrSizing()
end

function CritlineAnnounce_Localize()
	Critline_AnnounceAllButtonText:SetText(CL_RESETBUTTON_TEXT)
	CritlineAnnounce_SpellTitle:SetText(CL_ANNOUNCESPELLTITLE_TEXT)
end